#ifndef CALENDAR_H
#define CALENDAR_H

/********************************************************
** calendar.c
**
** Part of Calendar Project, Copyright (c) 2004-2005 [Yak]
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2.1 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
********************************************************/

#include <nokix/all.h>

/* handler mode */
#define CHM_INIT          0
#define CHM_EXIT          1
#define CHM_CHECK_DATE    2

void calendar_open(unsigned (*handler)(unsigned mode, unsigned *udata, void *arg));
void calendar_close(void);

void calendar_set_date(const struct date *date, bool full);
void calendar_get_date(struct date *date);

void calendar_draw(bool full);
bool calendar_keypress(unsigned key);

/* private */
#define DM_BOLD         (0xff)

#endif /* CALENDAR_H */

