
@/********************************************************
@** hooks_nokiacal.c
@**
@** Part of Calendar Project, Copyright (c) 2005 [Yak]
@**
@** Nokia Calendar hooks
@********************************************************/

.global hooks_nokiacal_start
hooks_nokiacal_start:

@-------------------------------------------
@ main hook, inserted at top

.global hook_nokiacal
hook_nokiacal:

push {r4,lr}

mov  r4,r0

cmp  r0,#0xc8
beq  handle_keypress    @ handle date movement
cmp  r0,#0xca
beq  return_dc          @ prevents from leaving to standby on keypresses

ldr  r1,msg_5dc
cmp  r0,r1
beq  handle_init
add  r1,#2
cmp  r0,r1
beq  handle_exit
add  r1,#9
cmp  r0,r1
beq  handle_refresh

ldr  r1,msg_366
sub  r1,r0,r1
cmp  r1,#1              @ 366 (key down) or 367 (key up)
bls  return_dc          @ disables original function of these keys

ldr  r1,msg_6bc
cmp  r0,r1
beq  handle_refresh_quick
add  r1,#0x25
cmp  r0,r1
beq  handle_refresh
add  r1,#7
cmp  r0,r1
beq  handle_refresh

return:
pop  {r4}

.global hook_nokiacal_code
hook_nokiacal_code:
nop
nop

pop  {pc}

return_dc:
mov  r0,#0xdc
b    return

return_r4:
mov  r0,r4
b    return

handle_init:
adr  r0,nokiacal_handler
bl   calendar_open
ldr  r0,msg_366
sub  r0,#0x39  @ 0x32d
bl   send_message
b    return_r4

handle_exit:
bl   calendar_close
b    return_r4

handle_refresh:
ldr  r0,_nokiacal_date
mov  r1,#1
bl   calendar_set_date
b    return_r4

handle_refresh_quick:
mov  r1,#0
bl   calendar_draw
b    return_r4

handle_keypress:
ldr  r0,_msg_argv
ldr  r0,[r0,#0]
cmp  r0,#5
beq  view_day
bl   calendar_keypress
cmp  r0,#0
beq  return_r4
@ date was changed, inform nokia calendar about it
ldr  r0,_nokiacal_date
bl   calendar_get_date
b    return_r4

view_day:
ldr  r0,msg_c5e0
.global mov_view_notes_id
mov_view_notes_id:
mov  r1,#0
mov  r2,#0
mov  r3,#0              @ R3: 0 - view notes for today, 1 - view all notes
bl   send_message
b    return_r4

@-------------------------------------------
@ replacement for original nokiacal_open() calls;

.global own_nokiacal_open
own_nokiacal_open:
push {lr}
ldr  r0,_nokiacal_date
mov  r1,#0
bl   calendar_set_date
pop  {pc}

@-------------------------------------------
@ this is the calendar handler, it is a hook called by calendar_draw()
@ when it needs to know if given day should be drawn in bold;
@ we use modified nokiacal_open() function to get this information

.align
nokiacal_handler:
push {r7,lr}
cmp  r0,#1 @ CHM_EXIT
beq  nch_exit
cmp  r0,#2 @ CHM_CHECK_DATE
bne  nch_end
@ copy checked date to nokia calendar's current date (used by nokiacal_open)
ldr  r0,_nokiacal_date
ldr  r1,[r2] @ whole struct date
str  r1,[r0] @ whole struct date
bl   nokiacal_open
mov  r0,r7
b    nch_end
nch_exit:
@ restore current date
ldr  r0,_nokiacal_date
bl   calendar_get_date
nch_end:
pop  {r7,pc}

.align

.global hook_nokiacal_data
hook_nokiacal_data:
.long 0

msg_5dc:
.long 0x5dc

msg_366:
.long 0x366

msg_6bc:
.long 0x6bc

msg_c5e0:
.long 0xc5e0

_msg_argv:
.long msg_argv

_nokiacal_date:
.long nokiacal_date

