
/********************************************************
** setting.c
**
** Part of Calendar Project, Copyright (c) 2004-2005 [Yak]
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2.1 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
********************************************************/

#include <nokix/all.h>
#include "calendar.h"

extern struct date struct_date[];

/* messages dispatcher */
unsigned cal_setting_disp(unsigned msg)
{
   switch(msg)
   {
      case MSG_D_INIT:
         calendar_open(NULL);

         calendar_set_date(struct_date+1,FALSE);

         msg=MSG_R_STAY;
         break;

      case MSG_D_QUIT:
         calendar_close();
         msg=MSG_R_QUIT;
         break;

      case MSG_KEYPRESS:
         calendar_keypress(own_get_unify_keycode(UKM_NPM5_CURSORS1));
         break;

      case MSG_KEYPRESS_ASCII:
         msg=MSG_NOP;
         break;

      case MSG_TIMESTAMP:
         calendar_draw(TRUE);
         break;

      case MSG_SELECT: /* OK */
         calendar_get_date(struct_date);
         send_message(MSG_REQUEST_QUIT_OK);
         break;
   }
   return msg;
}

